/* Wizards- ------------------------------------------------------------------*/
/* Includes ------------------------------------------------------------------*/
#include "Key_LED.h"

/* Exported types ------------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported variables --------------------------------------------------------*/
/* Exported functions prototypes ---------------------------------------------*/


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
//[BUTTON]:
// ●PA12腳位(PIN.05)，使用熱敏打印模組進紙按鍵Feed_Paper_SW腳，並設定腳位為PPO(Output Push-pull)
// ●PD9腳位(PIN.39)，使用熱敏打印模組暫停/列印測試按鍵STOP(Pause)_SW腳，並設定腳位為PPO(Output Push-pull)
#define LFKey               //PA12        //;AMO;2019.04.15
#define PauseKey            //PD9         //;AMO;2019.04.15


//[LED]:
// ●PA13腳位(PIN.06)，使用熱敏打印模組Paper_LED指示燈腳 ，並設定腳位為PPO(Output Push-pull)
// ●PA14腳位(PIN.07)，使用熱敏打印模組Power_LED指示燈腳 ，並設定腳位為PPO(Output Push-pull)
// ●PA15腳位(PIN.08)，使用熱敏打印模組Error_LED指示燈腳 ，並設定腳位為PPO(Output Push-pull)
#define Paper_LED_OFF       //PA13 = 0    //Check-Ok;AMO;2018.05.25   
#define Paper_LED_ON        //PA13 = 1    //Check-Ok;AMO;2018.05.25
#define Power_LED_OFF       //PA14 = 0    //Check-Ok;AMO;2018.05.25
#define Power_LED_ON        //PA14 = 1    //Check-Ok;AMO;2018.05.25   
#define ErrLED_OFF          //PA15 = 0    //Check-Ok;AMO;2018.05.25   
#define ErrLED_ON           //PA15 = 1    //Check-Ok;AMO;2018.05.25   



/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/


void KEY_LED_Initial(void)
{
  // GPIO Initial
    /* PA15 Error LED, PA3 Power LED, PB5 Peper LED, PC9 Ext LED2, PD2 Ext LED1  */
    GPIO_Init(GPIOA, GPIO_Pin_15, GPIO_MODE_OUT | GPIO_OTYPE_OD | GPIO_PUPD_NOPULL | GPIO_SPEED_HIGH | GPIO_AF0);
    GPIO_Init(GPIOA, GPIO_Pin_3, GPIO_MODE_OUT | GPIO_OTYPE_OD | GPIO_PUPD_NOPULL | GPIO_SPEED_HIGH | GPIO_AF0);
    GPIO_Init(GPIOB, GPIO_Pin_5, GPIO_MODE_OUT | GPIO_OTYPE_OD | GPIO_PUPD_NOPULL | GPIO_SPEED_HIGH | GPIO_AF0);
    // GPIO_Init(GPIOC, GPIO_Pin_9, GPIO_MODE_OUT | GPIO_OTYPE_OD | GPIO_PUPD_NOPULL | GPIO_SPEED_HIGH | GPIO_AF0);
    // GPIO_Init(GPIOD, GPIO_Pin_2, GPIO_MODE_OUT | GPIO_OTYPE_OD | GPIO_PUPD_NOPULL | GPIO_SPEED_HIGH | GPIO_AF0);


  // Ext Int Initial
    /* PB4 Feed Paper Key, PC13 STOP,  PD2 Key1,  PC9 KEY2 */
    GPIO_Init(GPIOB, GPIO_Pin_4, GPIO_MODE_IN | GPIO_OTYPE_OD | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF0);
    GPIO_Init(GPIOC, GPIO_Pin_13, GPIO_MODE_IN | GPIO_OTYPE_OD | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF0);
    // GPIO_Init(GPIOD, GPIO_Pin_2, GPIO_MODE_IN | GPIO_OTYPE_OD | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF0);
    // GPIO_Init(GPIOC, GPIO_Pin_9, GPIO_MODE_IN | GPIO_OTYPE_OD | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF0);
    
}


//=========================================================================================================
//* Function name:   PowerKey_Configuration
//* Descriptions :   电源按键中断模式
//=========================================================================================================
/*void PowerKey_Configuration(void)
{
    EXTI_InitTypeDef EXTI_InitStructure;
    GPIO_EXTILineConfig(GPIO_PortSourceGPIOC, GPIO_PinSource15);
    EXTI_InitStructure.EXTI_Line = EXTI_Line15;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;   //先屏蔽掉
    EXTI_Init(&EXTI_InitStructure);
}*/



